# JSplitter - Japanese capable splitter powerd by pykf & ChaSenTNG & ChaSen
# Auther - Yusei Tahara <pchi@din.or.jp>
# License - GPL
# Version 0.2

from string import maketrans, join, punctuation
import pykf
from ts_chasen import parse
from japanese_stop_words import stop_word_dict

keepcodes=range(1,13) + [16, 18] +range(20,25) + \
           [36, 37, 38, 44, 45, 48, 49, 52, 53, 54, 55, 72, 84]

class JSplitter:
        """Japanese capable splitter"""

        def __init__(self, doc='', stop_syn=None,encoding='', singlechar=0, indexnumbers=0, maxlen=32, casefolding=0):
                if stop_syn is None:
                        stop_syn={}
                stop_syn.update(stop_word_dict)
                doc=pykf.toeuc(doc, pykf.UNKNOWN)
                #t=maketrans('','')
                tmp=parse(doc)
                keywords=[]
                for i in tmp:
                        if i[1] in keepcodes:
                                keywords.append(i[0])
                        elif i[1]==17 and (i[0].isalpha() or pykf.guess(i[0])==3) and len(i[0])<=maxlen:
                                #word=i[0].translate(t,punctuation)
                                word=i[0]
                                if (singlechar or len(word)>1) and not word in stop_syn.keys():
                                        if not casefolding:
                                                word=word.lower()
                                        keywords.append(word)
                self.keywords=keywords
                self.unparsed=join(keywords,' ')
                #print self.unparsed

        def __getslice__(self, a, b):
                return self.keywords[a:b]

        def __getitem__(self, a):
                return self.keywords[a]

        def __len__(self):
                return len(self.keywords)

        def indexes(self, a):
                res=[]
                for i in range(len(self)):
                        if self[i]==a:
                                res.append(i)
                return res

        def pos(self, a):
                i=int(a/2)
                x=self.unparsed.find(self[i])
                return (x,x+len(self[i]))

        def split(self):
                return self.keywords

